const port = 6891;

function MSNFTP(file, authCookie, send, ip) {
  this.file = file;
  this.authCookie = authCookie;
  this.send = send;
  this.ip = ip;
  this.isConnectedToContact = false;
  this.transferCancelled = false;
}

MSNFTP.prototype.__proto__ = BaseConnection;

MSNFTP.prototype.onProtocolMessageReceived = function(msg, payload) {
  switch (msg[0]) {
    case "VER":
      this.isConnectedToContact = true;
      if (this.send == true) {
        this.sendData('VER MSNFTP\r\n');
      }
      else {
        this.sendData('USR renardbenoit@hotmail.com ' + this.authCookie + '\r\n');
      }
      break;
    case "USR":
      if (msg[2] == this.authCookie) {
        this.sendData('FIL ' + this.file.fileSize + '\r\n');
      }
      else {
        transferDone(2);
      }
      break;
    case "FIL":
      this.fileSize = msg[1];
      this.bytesLeft = this.fileSize;
      this.outputStream = Components.classes["@mozilla.org/network/safe-file-output-stream;1"]
                            .createInstance(Components.interfaces.nsIFileOutputStream);
      this.outputStream.init(this.file, 0x04 | 0x08 | 0x20, 0600, 0);
      this.binaryMode = true;
      this.sendData('TFR\r\n');
      transferStarted();
      break;
    case "TFR":
      transferStarted();
      this.sendFile();
      break;
    case "BYE":
      if (msg[1] == "16777989") {
        clearTimeout(this.waitForBYE);
        transferDone(0);
      }
      break;
    case "CCL":
      transferDone(1);
      break;
  }
}

MSNFTP.prototype.onBinaryDataReceived = function(binData, binDataLength) {
  this.outputStream.write(binData, binDataLength);
  this.bytesLeft -= binDataLength;
  showTransferProgress(Math.floor(((this.fileSize - this.bytesLeft) / this.fileSize) * 100));
  if (this.bytesLeft == 0) {
    if (this.outputStream instanceof Components.interfaces.nsISafeOutputStream) {
      this.outputStream.finish();
    }
    else {
      this.outputStream.close();
    }
    delete this.fileSize;
    delete this.bytesLeft;
    delete this.outputStream;
    this.sendData('BYE 16777989\r\n');
    transferDone(0);
  }
  else {
    if (this.transferCancelled == true) {
      transferDone(this.cancelValue);
    }
  }
}

MSNFTP.prototype.cancel = function(myCancel) {
  myCancel ? this.cancelValue = 3 : this.cancelValue = 1;
  if (this.isConnectedToContact == true) {
    this.transferCancelled = true;
  }
  else {
    transferDone(this.cancelValue);
  }
}

MSNFTP.prototype.close = function() {
  this.disconnect();
  this.stopListening();
  if (this.waitForBYE) {
    clearTimeout(this.waitForBYE);
  }
}

MSNFTP.prototype.onConnectionHeard = function() {
  this.isConnectedToContact = true;
  this.sendData('VER MSNFTP\r\n');
}

MSNFTP.prototype.open = function() {
  this.ip != null ? this.connect(this.ip, port) : this.listen(port);
}

MSNFTP.prototype.sendFile = function() {
  var bytesLeft = this.file.fileSize;
  var inputStream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                      .createInstance(Components.interfaces.nsIFileInputStream);
  var binaryStream = Components.classes["@mozilla.org/binaryinputstream;1"]
                       .createInstance(Components.interfaces.nsIBinaryInputStream);
  inputStream.init(this.file, -1, -1, false);
  binaryStream.setInputStream(inputStream);
  while (this.transferCancelled == false && bytesLeft != 0) {
    var header = '';
    var bytes = '';
    if (bytesLeft >= 2045) {
      header = String.fromCharCode(0, 253, 7);
      bytes = binaryStream.readBytes(2045);
      bytesLeft -= 2045;
    }
    else {
      header = String.fromCharCode(0, bytesLeft % 256, Math.floor(bytesLeft / 256));
      bytes = binaryStream.readBytes(bytesLeft);
      bytesLeft = 0;
    }
    this.sendData(header + bytes);
    showTransferProgress(Math.floor(((this.file.fileSize - bytesLeft) / this.file.fileSize) * 100));
  }
  if (this.transferCancelled == false) {
    this.waitForBYE = setTimeout(function() { transferDone(2); }, 60000);
  }
  else {
    transferDone(this.cancelValue);
  }
}